// Jean Luc Biellmann - contact@alsatux.com - 2013

var _C2XML = {

	info: function (id,mess) {
		var div = document.getElementById(id);
		div.innerHTML = mess;
	},

	backup: function () {

		_C2XML.info('result', '<p>Retrieving all contacts... Please be patient !</p>');

		var markup = '<?xml version="1.0" encoding="UTF-8"?><mozcontacts></mozcontacts>';
		var xmldoc = (new DOMParser()).parseFromString(markup, 'application/xml');
		var root = xmldoc.getElementsByTagName("mozcontacts")[0];

		var req = navigator.mozContacts.getAll({});
		var i = 1;
		req.onsuccess = function() {
			if (req.result) {
				var node = xmldoc.createElement('contact');
				root.appendChild(node);
				_C2XML.info('count', 'Contact N°' + (i++) + '...');
				_C2XML.export(xmldoc, node, req.result);
				req.continue();
			} else {
				_C2XML.info('count', i + ' contacts found !');
				var data = (new XMLSerializer()).serializeToString(xmldoc);
				_C2XML.save(data);
				_C2XML.info('result', '<p>XML datas:</p>' + data.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&apos;'));
			}
		};
		req.onerror = function() {
			_C2XML.info('result', '<p>Error getting contacts ! Program aborted !</p>');
		};

	},

	export: function (xmldoc, root, contact) {
		for (var nodeName in contact) {
			if (nodeName!=undefined && contact[nodeName]!=undefined && nodeName.match(/(id|published|updated)/)==null) {
				if (typeof(contact[nodeName])=='string') {
					var node = xmldoc.createElement(nodeName);
					root.appendChild(node);
					var text = xmldoc.createTextNode(contact[nodeName]);
					node.appendChild(text);
				} else { // object
					if (contact[nodeName].constructor != Array) {
						var node = xmldoc.createElement(nodeName);
						root.appendChild(node);
						_C2XML.export(xmldoc, node, contact[nodeName]);
					} else {
						if (contact[nodeName].length) {
							if (typeof(contact[nodeName][0])=='string') {
								for (var i=0;i<contact[nodeName].length;i++) {
									var node = xmldoc.createElement(nodeName);
									root.appendChild(node);
									var text = xmldoc.createTextNode(contact[nodeName][i]);
									node.appendChild(text);
								}
							} else {
								for (var i=0;i<contact[nodeName].length;i++) {
									var node = xmldoc.createElement(nodeName);
									root.appendChild(node);
									_C2XML.export(xmldoc, node, contact[nodeName][i]);
								}
							}
						}
					}
				}
			}
		}
	},

	twoDigits: function (value) {
		return (parseInt(value,10)<10 ? '0' : '') + value;
	},

	save: function (data) {
		var sdcard = navigator.getDeviceStorage('sdcard');

		var d = new Date();
		var yyyy = d.getFullYear();
		var mm = _C2XML.twoDigits(d.getMonth() + 1);
		var dd = _C2XML.twoDigits(d.getDate());
		var hh = _C2XML.twoDigits(d.getHours());
		var ii = _C2XML.twoDigits(d.getMinutes());
		var ss = _C2XML.twoDigits(d.getSeconds());
		var filename = 'contacts2xml/' + yyyy + mm + dd + hh + ii + ss + '.xml';

		var file = new Blob([data], {type: "text/plain"});
		var req = sdcard.addNamed(file, filename);
		req.onsuccess = function () {
			alert('File '+ filename + ' has been written to SD card !');
		}
		req.onerror = function () {
			alert('Unable to write datas to SD card !');
		}

	}

};

window.onload = function () {
	_C2XML.info('count', '');
	_C2XML.info('result', '');
	var but1 = document.getElementById('but1');
	but1.addEventListener("click", _C2XML.backup);
};
